## boot-floppies 2.2.26

=== Makefile ===
# Top-level Makefile for boot-floppies
#   see README* for information

# @@ Marcel FIXME: resc*.bin target for i386 make both resc*.bin and root*.bin:
#                  update scripts and clean make rules

# configurable variables reside in the config file
-include config

top_dir		:= $(CURDIR)

tmpdir		:= $(shell . ./common.sh; echo $$tmpdir)

# where to look for .deb files (local updates, archive base & admin dirs)
pathcmd		= ls -1ft $(CURDIR)/updates/P $(local_dir)/P $(archive)/base/P $(archive)/admin/P $(archive)/devel/P $(archive)/utils/P 2>/dev/null | head -1

kbd_package	:= $(shell $(pathcmd:P=console-data*.deb))

export GZIP	:= -9

# documentation rules live in documentation/Makefile*
-include documentation/Makefile.docs

#---------------------------------------------------------------------------

ifneq ($(strip $(findstring $(LINGUA),$(LATIN1))),)
	export FONT=lat1u-16.psf
endif
ifneq ($(strip $(findstring $(LINGUA),$(LATIN2))),)
	export FONT=iso02g.psf
endif
ifneq ($(strip $(findstring $(LINGUA),$(LATIN3))),)
	export FONT=iso03g.psf
endif
ifneq ($(strip $(findstring $(LINGUA),$(KOI8-R))),)
	export FONT=koi8-r.psf
endif

ifeq ($(FONT), iso02g.psf)
	export SFONT=iso02g.psf
endif
ifeq ($(FONT), iso03g.psf)
	export SFONT=iso03.f16
endif
ifeq ($(FONT), koi8-r.psf)
	export SFONT=koi8-r
endif

# shell needs to be set to base for the release target, at least
SHELL = bash

# [ED] avoid direct compilation of C programs from the utilities subdir
# (see the root.bin dependencies).  BTW utils target does the right job.
.SUFFIXES:

all::	build

null:
	: Null target for testing Makefile with "make -p null"

#---------------------------------------------------------------------------

ifneq ($(EXT),)
# if second call from build target (make EXT=...)
# build alternate rescue/drivers disks
    kver:=$(altkver)
    altkver:=
endif

# Only need major and minor numbers, not patchlevel.
KERNEL_VERSION_CODE := $(shell echo ${kver} | awk -FS=. '{v = ($$1 * 65536 + $$2 * 256); print v;}')

# find the newest kernel image of each type
kernel	:= $(shell $(pathcmd:P=kernel-image-$(kver)_*.deb))
# sanity fallback for kernel
ifeq ($(strip $(kernel)),)
kernel	:= kernel-image-$(kver)_$(kver)-1.deb
endif

ifndef pcmcia_kver
pcmcia_kver		:= $(kver)
endif

pcmcia_package		:= $(shell $(pathcmd:P=pcmcia-modules-$(pcmcia_kver)_*.deb))

#### i386 part
kerneli386_compact := $(shell $(pathcmd:P=kernel-image-$(kver)-compact_*.deb))
pcmciai386_compact := $(shell $(pathcmd:P=pcmcia-modules-$(kver)-compact_*.deb))
kerneli386_udma66 := $(shell $(pathcmd:P=kernel-image-$(kver)-ide_*.deb))
pcmciai386_udma66 := $(shell $(pathcmd:P=pcmcia-modules-$(kver)-ide_*.deb))
kerneli386_idepci := $(shell $(pathcmd:P=kernel-image-$(kver)-idepci_*.deb))
pcmciai386_idepci := $(shell $(pathcmd:P=pcmcia-modules-$(kver)-idepci_*.deb))

#### alpha part

# Please look in `config' and for instructions on where to get the
# various bits and bobs needed on Alpha, and how to set them up

# The list of subarchitectures to build for
alpha_arches		:= generic alcor avanti book1 cabriolet \
	eb164 eb64p eb66 eb66p jensen lx164 miata-s miata mikasa \
	noname noritake-p noritake p2k pc164 rawhide ruffian rx164 \
	sable-g sable sx164 xl xlt takara nautilus
alpha_milo_arches	:= alcor avanti book1 cabriolet eb164 eb64p \
	eb66 eb66p lx164 miata-s miata mikasa noname pc164 p2k \
	ruffian sx164 xl xlt takara
alpha_apb_arches	:= nautilus

# This gets the generic one
kernelalpha	        := $(shell $(pathcmd:P=kernel-image-$(kver)-generic*_alpha.deb))

ifeq ($(alpha_reduced_rescue_set),YES)
# We only build rescue disks for a subset of the available
# architectures (basically generic, and the ones where the generic
# kernel doesn't work)
alpha_rescue_arches     := generic jensen nautilus
else
alpha_rescue_arches	:= $(alpha_arches)
endif

# What we're actually going to build
alpha_rescue_targets	:= $(alpha_rescue_arches:%=resc1440_%.bin)
alpha_drivers_targets	:= $(alpha_rescue_arches:%=drv14alpha_%-1.bin)
ifeq ($(build_milo_disks),YES)
alpha_milo_targets	:= $(alpha_milo_arches:%=milo_%.bin)
endif

#### m68k part
# The list of subarchitectures to build for
kernelatari	:= $(shell $(pathcmd:P=kernel-image-$(kver)-atari*.deb))
kernelamiga	:= $(shell $(pathcmd:P=kernel-image-$(kver)-amiga*.deb))
kernelmac	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mac*.deb))
kernelbvme6000	:= $(shell $(pathcmd:P=kernel-image-$(kver)-bvme6000*.deb))
kernelmvme16x	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mvme16x*.deb))
kernelmvme147	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mvme147*.deb))

#### powerpc part
kernelapus	:= $(shell $(pathcmd:P=kernel-image-$(apuskver)-apus*.deb))
kernelchrp	:= $(shell $(pathcmd:P=kernel-image-$(kver)-chrp*.deb))
kernelmbx	:= $(shell $(pathcmd:P=kernel-image-$(kver)-mbx*.deb))
kernelpmac	:= $(shell $(pathcmd:P=kernel-image-$(kver)-pmac*.deb))
kernelprep	:= $(shell $(pathcmd:P=kernel-image-$(kver)-prep*.deb))
kernelsource	:= $(shell $(pathcmd:P=kernel-source-$(kver)*.deb))
kernelpatch	:= $(shell $(pathcmd:P=kernel-patch-$(kver)-powerpc*.deb))

#### arm part
kernel-riscpc	:= $(shell $(pathcmd:P=kernel-image-$(kver)-riscpc*.deb))
kernel-netwinder := $(shell $(pathcmd:P=kernel-image-$(kver)-netwinder*.deb))
kernel-shark	:= $(shell $(pathcmd:P=kernel-image-$(kver)-shark*.deb))

#### sparc part
# Sparc dist contains 3 kernels:
#  -sun4cdm (for non-sun4u)
#  -sun4dm-pci
#  -sun4u (ultrasparc)
ifeq ($(architecture),sparc)
  kernel64	:= $(shell $(pathcmd:P=kernel-image-$(kver)-sun4u_*.deb))
  kernel	:= $(shell $(pathcmd:P=kernel-image-$(kver)-sun4cdm_*.deb))
  kernelPCI	:= $(shell $(pathcmd:P=kernel-image-$(kver)-sun4dm-pci_*.deb))
endif


#---------------------------------------------------------------------------
# Consistency checks
#---------------------------------------------------------------------------

# Additional dependancy checks:
ifeq ($(architecture), i386)
  depends_checks := dosfstools syslinux zlib-bin
  tools_checks := rawrite2.zip lodlin16.zip
endif
ifeq ($(architecture), sparc)
  depends_checks := sparc-utils
endif
ifeq ($(architecture), alpha)
  depends_checks := aboot
endif
ifeq ($(architecture), powerpc)
  depends_checks := snarf dosfstools hfsutils
  CHECKFS := check_msdos
endif
ifeq ($(architecture), m68k)
  depends_checks := dosfstools hfsutils pmac-fdisk-cross
endif
ifeq ($(USE_LANGUAGE_CHOOSER), true)
  depends_checks += python-xml libpng2-dev libpopt-dev slang1-dev gconv-modules python-dev
endif

# check_minux disabled
check: localfiles check_mirror check_loop check_kernel check_depends check_tools $(CHECKFS)
	@echo "check successful"

# Use this to check if your kernel has support for the minix filesystem
check_minix:
	@grep minix /proc/filesystems 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/fs/minix.o || \
		( echo minix filesystem support needed; exit 1 )

# Use this to check if your kernel has support for the msdos filesystem
check_msdos:
	@grep msdos /proc/filesystems 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/fs/msdos.o || \
		( echo msdos filesystem support needed; exit 1 )

# Use this to check if your kernel has support for the loop device
check_loop:
	@grep loop /proc/devices 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/block/loop.o || \
		( echo loop device support needed ; exit 1 )

# Use this to check if your local mirror has all the required packages
check_mirror: check_mirror.sh
	./check_mirror.sh $(archive)

# Are our depends satisfied?  (i.e., for people using CVS)
check_depends:
	@echo checking boot-floppies dependancies
	@perl -e \
	  '$$_=`sed -n s/^Depends://Ip debian/control`."$(depends_checks)"; \
	   $$/="\n\n"; y/,/ /; s/\(.*?\)//g; @M{split()}=""; while (<>) { \
	     /^Status: \S+ \S+ installed$$/ms or next; \
	     delete $$M{$$1} if /^Package: (\S+)/ms; \
	     delete @M{split(/ *, */,$$1)} if /^Provides: (.+?)$$/ms; \
	   } foreach my $$m (keys %M) { print "  didn'\''t find $$m\n" } \
	   exit 1 if %M' /var/lib/dpkg/status

check_tools:
ifneq ($(tools_checks), )
	@echo "checking stuff in $(tools_dir)"
	@for t in $(tools_checks); do \
	  [ -f $(tools_dir)/$$t ] || { echo "  didn't find $$t"; e=1; }; \
	done; exit $$e
endif

# Use this to see if you have the proper kernels available
MSG=standard

check_kernel:
	@echo checking packages needed for kernel images
ifeq ($(architecture), i386)
	@[ -f "$(kernel)" ] || \
		( echo $(MSG) kernel \($(kver)\) is not available ; exit 1 )
	@[ -f "$(pcmcia_package)" ] || \
		( echo $(MSG) PCMCIA modules \($(pcmcia_kver)\) are not available ; exit 1 )
	@[ -f "$(kerneli386_compact)" ] || \
		( echo compact kernel is not available ; exit 1 )
	@[ -f "$(pcmciai386_compact)" ] || \
		( echo compact flavor PCMCIA modules are not available ; exit 1 )
	@[ -f "$(kerneli386_udma66)" ] || \
		( echo udma66 kernel is not available ; exit 1 )
	@[ -f "$(pcmciai386_udma66)" ] || \
		( echo udma66 flavor PCMCIA modules are not available ; exit 1 )
	@[ -f "$(kerneli386_idepci)" ] || \
		( echo idepci kernel is not available ; exit 1 )
	@[ -f "$(pcmciai386_idepci)" ] || \
		( echo idepci flavor PCMCIA modules are not available ; exit 1 )
else
ifeq ($(architecture), m68k)
	@[ -f "$(kernelatari)" ] || \
		( echo atari kernel is not available ; exit 1 )
	@[ -f "$(kernelamiga)" ] || \
		( echo amiga kernel is not available ; exit 1 )
	@[ -f "$(kernelmac)" ] || \
		( echo mac kernel is not available ; exit 1 )
	@[ -f "$(kernelbvme6000)" ] || \
		( echo bvme6000 kernel is not available ; exit 1 )
	@[ -f "$(kernelmvme16x)" ] || \
		( echo mvme16x kernel is not available ; exit 1 )
	@[ -f "$(kernelmvme147)" ] || \
		( echo mvme147 kernel is not available ; exit 1 )
else
ifeq ($(architecture), powerpc)
	@[ -f "$(kernelapus)" ] || \
		( echo apus kernel is not available ; exit 1 )
	@[ -f "$(kernelchrp)" ] || \
		( echo chrp kernel is not available ; exit 1 )
	@[ -f "$(kernelpmac)" ] || \
		( echo pmac kernel is not available ; exit 1 )
	@[ -f "$(kernelprep)" ] || \
		( echo prep kernel is not available ; exit 1 )
	@[ -f "$(kernelsource)" ] || \
		( echo kernel source is not available ; exit 1 )
	@[ -f "$(kernelpatch)" ] || \
		( echo kernel patch is not available ; exit 1 )
	@[ -f "$(pcmcia_package)" ] || \
		( echo $(MSG) PCMCIA modules are not available ; exit 1 )
else
ifeq ($(architecture), sparc)
	@[ -f "$(kernel)" ] || \
		( echo $(MSG) sun4cdm kernel is not available ; exit 1 )
	@[ -f "$(kernel64)" ] || \
		( echo $(MSG) sun4u kernel is not available ; exit 1 )
	@[ -f "$(kernelPCI)" ] || \
		( echo $(MSG) sun4dm-pci kernel is not available ; exit 1 )
else
ifeq ($(architecture), alpha)
	@[ -f "$(kernelalpha)" ] || \
		( echo $(MSG) kernel is not available ; exit 1 )
else
ifeq ($(architecture), arm)
	@[ -f "$(kernel-riscpc)" ] || \
		( echo $(MSG) riscpc kernel is not available ; exit 1 )
	@[ -f "$(kernel-netwinder)" ] || \
		( echo $(MSG) netwinder kernel is not available ; exit 1 )
#	@[ -f "$(kernel-shark)" ] || \
#		( echo $(MSG) shark kernel is not available ; exit 1 )
else
	@echo unsupported architecture: $(architecture); false
endif
endif
endif
endif
endif
endif
ifneq ($(altkver),)
	$(MAKE) check_kernel EXT=-$(altkver) MSG=alternative
endif

#---------------------------------------------------------------------------
# Don't edit below this line

ifeq ($(architecture), sparc)
silo_pkg		:= $(shell $(pathcmd:P=silo_*.deb))
arch_rootdisk_deps	:= silo1440k-sun4cdm.gz silo1440k-sun4u.gz
arch_rescue_deps	:= silo1440k-sun4cdm.gz silo1440k-sun4u.gz
endif

localfiles:: updates
	cd $(incoming) && \
	  find . \( -name '*_all.deb' -o -name '*_$(architecture).deb' \) -exec cp {} $(CURDIR)/updates/ \;
	cd $(local_dir) && \
	  find . -name '*.deb' -exec cp {} $(CURDIR)/updates/ \;

# dependency for the files that have to be copied
updates::
	[ -d updates ] || mkdir -p updates

# helper target to mirror base locally
mirror:
	[ -d $(archive) ] || mkdir -p $(archive)
	cd $(archive) && $(top_dir)/mirror_base.sh $(architecture)	\
