=== powerpc-specials/Makefile ===
# Makefile for PowerPC install documentation and BootX fetching
#
# Docs are english version and TXT for now
# but could be html, ps or pdf

-include ../config

ifeq ($(LINGUA),C)
   LINGUA := en
endif

all:
	sgml2txt install-chrp.$(LINGUA).sgml
	sgml2txt install-pmac.$(LINGUA).sgml
	sgml2txt install-prep.$(LINGUA).sgml
	sgml2txt install-apus.$(LINGUA).sgml

	# Fetch BootX and bootvars tools - these should be in tools/   
	snarf http://penguinppc.org/~benh/BootX_1.2.2.sit
	snarf http://http.us.debian.org/debian/dists/stable/main/disks-powerpc/current/powermac/bootvars1.3b.sit.hqx

clean:
	rm -f install-*.txt BootX* bootvars* yaboot* ybin*
