=== utilities/Makefile ===

include ../config

CC			:= gcc
CFLAGS			:= -O2 -fomit-frame-pointer
LDFLAGS			:= -s
arch			:= $(shell dpkg --print-architecture)

SUBDIRS	:= libfdisk dbootstrap busybox writemaps

ifneq ($(arch),m68k)
  SUBDIRS	+= lowmemrd
endif

ifeq ($(USE_LANGUAGE_CHOOSER),true)
# bogl enabled
SUBDIRS	+= bogl
endif

SPLIT_OBJECTS	:= floppy_split.o

all:		floppy_split $(SUBDIRS)

.PHONY:		$(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@ KVER=${KVER} KERNEL_VERSION_CODE=${KERNEL_VERSION_CODE}

clean:
	rm -f *.o *.bak po.utf rn.utf all.utf
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done

distclean: clean
	rm -f floppy_split
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i distclean; done

floppy_split: $(SPLIT_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(SPLIT_OBJECTS)

# dependancies
$(SPLIT_OBJECTS):	floppy_split.h
