=== documentation/ru/Makefile ===
orig_dir=../en
diff_args=-ub

chapters= administrivia dbootstrap hardware inst-methods partitioning post-install preparing rescue-boot tech-info welcome appendix

all:    # do nothing

help:
	@echo Please specify what you want to do
	@echo Possible actions are:
	@echo   diff            -- check all registered documents
	@echo   diff-\<document\> -- check whether the original of the specified document has changed
	@echo
	@echo Please note, that \<document\> should not contain .sgml extension

diff: $(addprefix diff-,$(chapters))

diff-%: %.sgml
# @echo $<: $(shell fgrep "english version" $< | sed -e 's/^  english version: unknown//; s/^  english version: \(.*\)/-r\1/')
	-cvs -z6 diff $(diff_args) $(shell fgrep "english version" $< | sed -e 's/^  english version: unknown//; s/^  english version: \(.*\)/-r\1/') ../en/$<

clean:
