=== powerpc-specials/coffboot/Makefile ===
CC      = $(CROSS_COMPILE)gcc
HOST_CC = gcc
LD      = $(CROSS_COMPILE)ld
CFLAGS  = -O -fno-builtin
OBJCOPY = $(CROSS_COMPILE)objcopy
OBJCOPY_ARGS = -O aixcoff-rs6000 -R .stab -R .stabstr -R .comment --add-section=image=vmlinux.gz
LD_ARGS = -e _start -T ld.script -Ttext 500000 -Tdata 510000 -Bstatic
GZ = gzip -9

OBJS = crt0.o ctype.o errno.o start.o main.o misc.o string.o vsprintf.o zlib.o

coffboot: $(OBJS) ld.script
	$(LD) -o coffboot $(LD_ARGS) $(OBJS)

hack-coff: hack-coff.c
	$(HOST_CC) $(CFLAGS) -o hack-coff hack-coff.c

vmlinux.gz: ../../linuxpmac
	$(OBJCOPY) -S -O binary ../../linuxpmac vmlinux
	gzip -9fv vmlinux

ramdisk.image.gz: ../../rootpmac.bin
	cp $< $@

../../rescue-pmac.coff: coffboot hack-coff vmlinux.gz ramdisk.image.gz
	$(OBJCOPY) $(OBJCOPY_ARGS) --add-section=initrd=ramdisk.image.gz coffboot $@
	./hack-coff $@

clean:
	rm -f coffboot hack-coff vmlinux.gz ramdisk.image.gz *.o *~
