=== utilities/lowmemrd/Makefile ===
KVER =
OBJECTS = linuxrc.o mkswap.o fdisk.o llseek.o
LIBS = ../libfdisk/libfdisk.a /usr/lib/libz.a

CFLAGS = -O2 -Wall -s
ifneq ($(findstring 2.0.,$(KVER)),)
CFLAGS += -DOLDKERNEL
endif

all: linuxrc

linuxrc: $(OBJECTS) $(LIBS)
	$(CC) $(CFLAGS) -static -Wall -o linuxrc $(OBJECTS) $(LIBS)

clean:
	rm -f *.o 

distclean: clean
	rm -f linuxrc zcat
