=== utilities/writemaps/Makefile ===
ifndef DATADIR
DATADIR = /usr/share/keymaps
endif

ifndef BINDIR
BINDIR = /usr/bin
endif

PROGS   = loadkeys 

WARN	= -Wall
DEFS	= -DDATADIR=\"$(DATADIR)\"
CFLAGS  = -O2
LDFLAGS = -s

CC	= gcc
YACC	= bison -y
LEX	= flex -8

default:	$(PROGS)

.c.o:
	$(CC) -c $(WARN) $(CFLAGS) $(DEFS) $<

all: $(PROGS)

# loadkeys.o: separate rule since the flex output does not permit -Wall
loadkeys.o:	loadkeys.c analyze.c
	$(CC) -c $(CFLAGS) $(DEFS) $<


distclean clean:
	rm -f core *.o analyze.c loadkeys.c loadkeys

$(PROGS): %: %.o

loadkeys: ksyms.o findfile.o getfd.o

ksyms.o: cyrillic.syms.h ethiopic.syms.h

loadkeys.o: paths.h
