=== debian/changelog ===
boot-floppies (2.2.26) stable; urgency=low
  
  * Ethan Benson:
    - Fix powerpc bootloader installation to simply display a rtfm dialog
      if its run on a NewWorld, it can't install yaboot in potato.
    - Fix powerpc bootloader installation to setup /target/etc/quik.conf
      correctly.
    - Add dialog to the end of quik installation informing the user they
      have to fix OpenFirmware themselves and thier machine still won't
      actually boot yet.
  * Tommi Vainikainen: Finnish documentation updates
  * rebuild for new Potato post r3 updates

 -- Adam Di Carlo <aph@debian.org>  Tue, 12 Jun 2001 18:55:51 -0500
  

boot-floppies (2.2.25) stable; urgency=low

  * bump i386 to kernel 2.2.19
  * Chris Tillman: PowerMac documentation additions
  * Ethan Benson: PowerMac documentation corrections
  * Marcin Owsiany: fixed a typo in Polish docs (thanks to Micha Matysiak)
  * Phil Blundell:
    - include ne2k-pci driver on ARM systems
    - correct arm specifics in release.sh
  * David Whedon: DOS/Windows, Atari and MacOS floppy disk creation now
    seen by all archs

 -- Adam Di Carlo <aph@debian.org>  Thu,  7 Jun 2001 01:20:52 -0500

boot-floppies (2.2.24) stable; urgency=low

  * Phil Blundell: ARM fixes for the following:
    - NetWinder kernel is now "Image" not "vmlinuz"
    - 2.2.19 "tulip" driver breaks on NetWinder; use "old_tulip" instead
    - build NetWinder TFTP image
    - correct name of RiscPC keymap
    - documentation updates
  * Fabian Wauthier: German rescue disk translation updates
  * Chris Tillman: documentation corrections
  * Marcin Owsiany: added Polish dselect-beginner translation contributed by
    Pawe Tcza <pawel.tecza@poland.com>

 -- Adam Di Carlo <aph@debian.org>  Fri, 11 May 2001 00:57:02 -0400

boot-floppies (2.2.23) stable; urgency=low

  * Matt Kraai:
    - fix the drive_blocks array for hdg, hdh, hdi, and hdj
      (closes: Bug#90967)
  * Daniel Jacobowitz:
    - bump PowerPC to kernel 2.2.19.
    - fix URLs for bootx/bootvars
    - use \( \) in Makefile find invocation
    - bootprep.sh: Turn on CONFIG_IP_PNP_ENABLE also
  * Phil Blundell:
    - bump ARM kernel to 2.2.19

 -- Adam Di Carlo <aph@debian.org>  Sat, 14 Apr 2001 20:02:35 -0400

boot-floppies (2.2.22) stable; urgency=low

  * use 2.2.19pre17 kernels/modules on i386
  * documentation: talk about 'hda=noautotune' required on PowerMacs
    sometimes
  * i386 syslinux.cfg: pass through the disksize and flavor arguments to
    the other types of install methods, i.e., initrd, ramdisk*, floppy*;
    otherwise, it wouldn't know it's flavor and would try to use
    the wrong images
      -- THIS WAS A RATHER BAD BUG which affected CD and floppy installs
         on i386
  * rootdisk: fix building of i386 i18n images by bumping up inodes
  * dbootstrap: if we're i18n mode, write an entry 'LANGUAGE' in
    /root/dbootstrap_settings

 -- Adam Di Carlo <aph@debian.org>  Tue, 27 Mar 2001 01:46:35 -0600

boot-floppies (2.2.21) stable; urgency=low

  * Michael Sobolev
    - language chooser allows a default language
    - some Russian dbootstrap message updates
    - README-Translators: improvements
  * Paul Romanchenko: Russian dbootstrap updates and fixes
  * Marcin Owsiany <porridge@pandora.info.bielsko.pl>
    - Polish documentation updates
    - some language chooser build problems fixed
    - README-Translators: improvements
  * Peter Karlsson: Swedish dbootstrap updates
  * Erik Andersen <andersen@lineo.com>: Busybox fixes for loop device
    (closes: Bug#64500)
  * Karl Hammar: syslinux documentation for working around a loop when
    downloading SCSI scripts on NCR-based HBAs
  * Ethan Benson: PowerPC documentation improvements (closes: Bug#69161)
  * Adam Di Carlo:
    - sparc: bump kernel to 2.2.19pre11
    - alpha: bump kernel to 2.2.19pre13
    - Makefile: fix the localfiles rule, which was breaking in some
      instances; fix mirror-to-master rule in documentation/Makefile
    - Maintainers: credit Bill Bennet, The ComputerHelperGuy, for his
      donation of CD sets
    - documentation: fix alpha driver files (closes: Bug#78521); remove
      some stale stuff left over from slink, esp in the dbootstrap info;
      fix bad external links and some bad internal links 
      (closes: Bug#82024); update downloadable files based on newest
      released boot-floppies; talk about mounting stuff manually and other
      improvements (closes: Bug#69786); remove slink'isms from Chapter 7,
      adding a pretty much whole new discussion of the base-config steps;
      discuss install extra modules from floppy; update copyright notice;
      document booting from different CDs for different flavors on i386;
      discussion of Solaris/*BSD slices next to fdisk/cfdisk 
      (closes: Bug#65903); more stuff required in replacement rescue kernels
    - include French Release Notes
    - dbootstrap: minor message changes so things are more understandable;
      when we ask for the Debian CD-ROM, ask specifically for the *first*
      CD-ROM; ask fewer questions about archive locations, in fact, no
      questionsin the cases that some is using a media where things are
      where we can find them (closes: Bug#82912) the "load modules from
      floppy" step was reworded a bit to make it more clear that this an
      extra, non-std thing; fix some gratuitous references to floppies in
      the welcome message
    - release notes: fix a bad link on i386 to ports
    - README-Users.m4 (top-level README): fix alpha subarch reference;
      mention that local copies of stuff should retain the directory
      structure; improve discussion of various files; spell fixes
    - README-{flavors} (i386): put as README.txt in <flavor> dirs as
      well; refer users to the top-level README.txt for information on
      what the files are for
    - termwrap won't fail miserably if /etc/environment doesn't exist
      (closes: Bug#81319)
    - rootdisk: add /dev/ida/c[01]d[0123] devices back, which were

