=== debian/control ===
Source: boot-floppies
Section: devel
Priority: extra
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Standards-Version: 3.1.1
Build-Depends-Indep: debhelper
Build-Depends: glibc-pic, slang1-pic, libnewt-dev, libpopt-dev, zlib1g-dev, recode, gettext, m4, debiandoc-sgml, libi18n-langtags-perl, man-db, libpaperg, tetex-bin, tetex-extra, perl5, libwww-perl, pointerize, libgd1g-dev, bison, ash, dpkg-awk, flex, file, rsync, debhelper, gawk, cslatex, cspsfonts

Package: boot-floppies
Architecture: all
Depends: dpkg-dev, gcc, glibc-pic, slang1-pic, libnewt-dev, libpopt-dev, zlib1g-dev, recode, make, gettext, m4, debiandoc-sgml, libi18n-langtags-perl, man-db, libpaperg, tetex-bin, tetex-extra, perl5, libwww-perl, pointerize, libgd1g-dev, bison, ash, dpkg-awk, flex, file, rsync, debhelper, gawk, cslatex, cspsfonts
Suggests: python-xml
Description: Scripts to create the Debian installation floppy set.
 This package allows you to create a Debian installation system on floppy
 disk or other media, for bootstrapping Debian onto a new system. Most users
 will simply download the disk images to do this, and this package will
 generally only be used by advanced Debian maintainers.
